# Class VulkanExtent3D

java.lang.Object
com.io7m.jcoronado.api.VulkanExtent3D

All Implemented Interfaces:
  `VulkanExtent3DType`

public final class VulkanExtent3D extends Object implements VulkanExtent3DType
Structure specifying a three-dimensional extent.

See Also:
  - "VkExtent3D"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanExtent3D.Builder`
  Builds instances of type `VulkanExtent3D`.

- ## Field Summary

  ### Fields inherited from interface VulkanExtent3DType

  `ZERO`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanExtent3D.Builder`
  `builder()`
  Creates a builder for `VulkanExtent3D`.
  `static VulkanExtent3D`
  `copyOf(VulkanExtent3DType instance)`
  Creates an immutable copy of a `VulkanExtent3DType` value.
  `int`
  `depth()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanExtent3D` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `width`, `height`, `depth`.
  `int`
  `height()`
  `String`
  `toString()`
  Prints the immutable value `VulkanExtent3D` with attribute values.
  `int`
  `width()`
  `final VulkanExtent3D`
  `withDepth(int value)`
  Copy the current immutable object by setting a value for the `depth` attribute.
  `final VulkanExtent3D`
  `withHeight(int value)`
  Copy the current immutable object by setting a value for the `height` attribute.
  `final VulkanExtent3D`
  `withWidth(int value)`
  Copy the current immutable object by setting a value for the `width` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### width

    public int width()
    Specified by:
      `width` in interface `VulkanExtent3DType`
    Returns:
      The width of the extent

  - ### height

    public int height()
    Specified by:
      `height` in interface `VulkanExtent3DType`
    Returns:
      The height of the extent

  - ### depth

    public int depth()
    Specified by:
      `depth` in interface `VulkanExtent3DType`
    Returns:
      The depth of the extent

  - ### withWidth

    public final VulkanExtent3D withWidth(int value)
    Copy the current immutable object by setting a value for the `width` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for width
    Returns:
      A modified copy or the `this` object

  - ### withHeight

    public final VulkanExtent3D withHeight(int value)
    Copy the current immutable object by setting a value for the `height` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for height
    Returns:
      A modified copy or the `this` object

  - ### withDepth

    public final VulkanExtent3D withDepth(int value)
    Copy the current immutable object by setting a value for the `depth` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for depth
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanExtent3D` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `width`, `height`, `depth`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanExtent3D` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanExtent3D copyOf(VulkanExtent3DType instance)
    Creates an immutable copy of a `VulkanExtent3DType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanExtent3D instance

  - ### builder

    public static VulkanExtent3D.Builder builder()
    Creates a builder for `VulkanExtent3D`.

        VulkanExtent3D.builder()
           .setWidth(int) // optional width
           .setHeight(int) // optional height
           .setDepth(int) // optional depth
           .build();

    Returns:
      A new VulkanExtent3D builder